; Simple sample how to use stereo anaglyph render (by ABTOMAT)

; You MUST include these two files:
Include "include\FastImage.bb" ; FastImage by Mihail Vostrikov (www.fastlibs.com)
Include "Anaglyph.bb"

Graphics3D 1280,1024,32,1
SetBuffer BackBuffer()

SeedRnd MilliSecs()

InitDraw()

InitAnaglyph() ; Init stereo

cam = CreateCamera()
TurnEntity cam,30,0,0
PositionEntity cam,0,10,0
light = CreateLight()
TurnEntity light,45,45,45

; Let's create some objects to see in stereo-mode ;)

BuildingTexture = CreateTexture (256,256)

SetBuffer TextureBuffer(BuildingTexture)
Color 200,200,200
Rect 0,0,256,256,1
Color 128,128,128
For i=0 To 16
	For j=0 To 16
		Rect i*16+1,j*16+1,14,14
	Next
Next

ScaleTexture BuildingTexture,1,1


For i = 0 To 300 
	c = CreateCube()
	PositionEntity c,Rand(-100,100),0,Rand(5,100)
	ScaleEntity c,Rnd(1,2),Rnd(3,10),Rnd(1,2)
	EntityColor c,Rand(128,255), Rand(128,255), Rand(128,255)
	EntityTexture c, BuildingTexture
Next

FreeTexture BuildingTexture

GrassTexture = CreateTexture (256,256)

SetBuffer TextureBuffer(GrassTexture)
Color 0,200,64
Rect 0,0,256,256,1
Color 64,128,64
For i=0 To 1024
	sx = Rand(0,256)
	sy = Rand(0,256)
	Line sx,sy, sx+Rand(5,30), sy+Rand(5,30)	
Next

ScaleTexture grasstexture,10,10

SetBuffer BackBuffer()


Plane = CreatePlane()
EntityTexture plane, GrassTexture 
FreeTexture GrassTexture 

Repeat
cycletime = MilliSecs()

PositionEntity cam, 0,(Sin(MilliSecs()/Float(100))+2)*5,0

;RenderWorld
AnaglyphRender(cam,.5) ; Use AnaglyphRender in place of RenderWorld!

Flip 0

dt = MilliSecs()-cycletime
Until KeyHit(1)

End